
#ifndef __Mod_GScript_Core__
#define __Mod_GScript_Core__

//---- XNvgsRAW[

#module "ModGS_Core"

#define global gsc_core_SelectCode(%1)		_gsc_code_ID=%1:gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
#define global gsc_core_SetAddress(%1)		_gsc_addr=%1
#define global gsc_core_StackPush(%1)		gsc_stack_push:_gsc_cur_stack_type=%1:_gsc_cur_stack_code=_gsc_code_ID:_gsc_cur_stack_addr=_gsc_addr

	//	eval
	#defcfunc gsc_Eval str p_code, local code_id, local thread_id
		gsc_reset
		code_id = gs_compile_main( p_code, 0) : if code_id < 0 : return 0;-1
		thread_id = gsc_thread_create()
		gsc_thread_setcode thread_id, code_id
		gs_core_main thread_id
		gsc_thread_delete thread_id
		gsc_delete code_id
		gs_code_ns_decrease
		if _gsc_error {
			gsc_reset
			return 0;-2
		}
		return _gsc_run_thread_return

	//	label call
	#defcfunc gsc_LCall str p_label, local thread_id
		gsc_reset
		thread_id = gsc_thread_create()
		gsc_thread_setlabel thread_id, p_label : if stat < 0 : gsc_thread_delete thread_id : return 0
		gs_core_main thread_id
		gsc_thread_delete thread_id : if _gsc_error : gsc_reset : return 0
		return _gsc_run_thread_return

	#define global gsc_Main		gs_core_main 0
	#deffunc gs_core_main int p_thread
		//	p_thread	0	SXbhs
		//				1~n	Cӂ̃Xbhs

		//	G[`FbN
		if _gsc_error : return

		//	Xbh̐mF
		if gs_thread_get_thread_count() == 0 : return

		//	gsc_main s gsc_main Ăяô͋Ȃ
		if _gsc_core_flag != 0 : return

		gs_log_Push
		gs_log_Write "GS Core begin: "+p_thread

		_gsc_core_flag++

		_gsc_run_thread_id = p_thread
		if _gsc_run_thread_id > 0 {
			gosub *CORE_THREAD_ONE
		} else {
			gosub *CORE_THREAD_ALL
		}

		_gsc_core_flag--

		gs_log_Push
		gs_log_Write "GS Core end: "+p_thread

		return _gsc_error



*CORE_THREAD_ONE	//	eval,lcallp

		;if varuse(Gmd_Thread_Container@ModGS_Thread(_gsc_run_thread_id)) == 0 : return
		if gs_thread_get_thread_state(_gsc_run_thread_id) == 0 : return
		_gsc_run_thread_return = 0

		repeat 1

			//	ThreadID𒼐ړ
			_gsc_thread = _gsc_run_thread_id;gs_thread_get_tid_from_sid(_gsc_run_thread_id)

			//	Xbh̃VXeldup
			gs_thread_system_dup _gsc_thread, _gsc_code_ID, _gsc_addr, _gsc_flag, _gsc_wait, _gsc_stat, _gsc_refdval, _gsc_refstr
			if (_gsc_flag & GSMD_THREAD_FLAG_MASK_EXECUTE) == GSMD_THREAD_FLAG_EXECUTE_STOP {
				continue
			}
			if _gsc_wait {
				if _gsc_wait > 0 : _gsc_wait--
				continue
			}

			//	X^bN{̂ƃR[hdup
			gs_thread_stack_dup	_gsc_thread, _gsc_stack_index, _gsc_stack_type, _gsc_stack_code, _gsc_stack_addr, _gsc_stack_max, _gsc_stack_cnt
			gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size

			//	VXeϐ̒lϐɏ
			_gsc_sv_stat	= _gsc_stat
			_gsc_sv_refdval	= _gsc_refdval
			_gsc_sv_refstr	= _gsc_refstr
			_gsc_sv_cnt		= _gsc_stack_cnt(_gsc_stack_index)

			//	X^bNZbgu[N؂
			gsc_stack_set
			_gsc_break = 0


			//	s{
			gosub *CORE_MAIN

			//	G[ꍇ̓Xbh폜
			if _gsc_error {
				gs_thread_delete _gsc_thread
				break
			}

			//	VXeϐ̒lXbh̃VXeϐɏ
			_gsc_stat		=	_gsc_sv_stat
			_gsc_refdval	=	_gsc_sv_refdval
			_gsc_refstr		=	_gsc_sv_refstr
		loop
		return



*CORE_THREAD_ALL	//	gsc_mainp

		_gsc_thread_order = -1
		repeat -1

			//	XbhI[_[玟̃XbhSystemID擾ThreadIDɕϊ
			_gsc_thread_order = gs_thread_order_get_next(_gsc_thread_order)
			if _gsc_thread_order == -1 : break
			_gsc_thread = gs_thread_get_tid_from_sid( gs_thread_order_get_value(_gsc_thread_order) )

			//	Xbh̃VXeldup
			gs_thread_system_dup _gsc_thread, _gsc_code_ID, _gsc_addr, _gsc_flag, _gsc_wait, _gsc_stat, _gsc_refdval, _gsc_refstr
			if (_gsc_flag & GSMD_THREAD_FLAG_MASK_EXECUTE) == GSMD_THREAD_FLAG_EXECUTE_STOP {
				continue
			}
			if _gsc_wait {
				if _gsc_wait > 0 : _gsc_wait--
				continue
			}

			//	X^bN{̂ƃR[hdup
			gs_thread_stack_dup	_gsc_thread, _gsc_stack_index, _gsc_stack_type, _gsc_stack_code, _gsc_stack_addr, _gsc_stack_max, _gsc_stack_cnt
			gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size

			//	VXeϐ̒lϐɏ
			_gsc_sv_stat	= _gsc_stat
			_gsc_sv_refdval	= _gsc_refdval
			_gsc_sv_refstr	= _gsc_refstr
			_gsc_sv_cnt		= _gsc_stack_cnt(_gsc_stack_index)

			//	X^bNZbgu[N؂
			gsc_stack_set
			_gsc_break = 0

			//	s{
			gosub *CORE_MAIN

			//	G[ꍇ̓Xbh폜
			if _gsc_error {
				gs_log_Write "Error -> Thread delete: "+_gsc_thread
				gs_thread_delete _gsc_thread
				break
			}

			//	VXeϐ̒lXbh̃VXeϐɏ
			_gsc_stat		=	_gsc_sv_stat
			_gsc_refdval	=	_gsc_sv_refdval
			_gsc_refstr		=	_gsc_sv_refstr

		loop

		return



*CORE_MAIN
			//	s{
	
			gs_log_Push
			gs_log_Write "Thread begin: "+_gsc_thread

			repeat gs_thread_get_autobreak(_gsc_thread)

				gs_log_Push

				_gsc_op_head = _gsc_addr
				code_type = peek(_gsc_code_bin,_gsc_addr) : _gsc_addr++

				if code_type == 'f' {	//	
					_gsc_funcid = wpeek(_gsc_code_bin,_gsc_addr) : _gsc_addr += 2
					param_count = gs_function_get_p_count(_gsc_funcid)

					if param_count > 0 {	//	ꍇ
						_gsc_funcsize = wpeek(_gsc_code_bin,_gsc_addr) : _gsc_addr += 2
						if _gsc_funcsize > 0 {		//	w肳Ăꍇ͌vZX^bNɃp[^ς
							gs_calculate_core _gsc_code_bin, _gsc_addr
							_gsc_addr += _gsc_funcsize
							if _gsc_error {
								goto *@f
							}
						} else {					//	SďȗĂꍇ̓X^bN𖄂߂
							gs_calculate_fillstack 0, param_count
						}
						;if param_count > 0 {		//	X^bÑp[^ϐɐU蕪Aɗꍇ͕K1ȏゾ炱if͏Ȃ
							gs_calculate_getstack _gsc_p1, _gsc_i1, 0, gs_function_get_p_type(_gsc_funcid,0) : if stat == -2 : goto *@f
						if param_count > 1 {
							gs_calculate_getstack _gsc_p2, _gsc_i2, 1, gs_function_get_p_type(_gsc_funcid,1) : if stat == -2 : goto *@f
						if param_count > 2 {
							gs_calculate_getstack _gsc_p3, _gsc_i3, 2, gs_function_get_p_type(_gsc_funcid,2) : if stat == -2 : goto *@f
						if param_count > 3 {
							gs_calculate_getstack _gsc_p4, _gsc_i4, 3, gs_function_get_p_type(_gsc_funcid,3) : if stat == -2 : goto *@f
						if param_count > 4 {
							gs_calculate_getstack _gsc_p5, _gsc_i5, 4, gs_function_get_p_type(_gsc_funcid,4) : if stat == -2 : goto *@f
						if param_count > 5 {
							gs_calculate_getstack _gsc_p6, _gsc_i6, 5, gs_function_get_p_type(_gsc_funcid,5) : if stat == -2 : goto *@f
						if param_count > 6 {
							gs_calculate_getstack _gsc_p7, _gsc_i7, 6, gs_function_get_p_type(_gsc_funcid,6) : if stat == -2 : goto *@f
						if param_count > 7 {
							gs_calculate_getstack _gsc_p8, _gsc_i8, 7, gs_function_get_p_type(_gsc_funcid,7) : if stat == -2 : goto *@f
						}}}}}}};}
						*@
						if _gsc_error {
							gs_log_Write "ERROR: "+gs_function_get_name(_gsc_funcid)+gs_function_get_combined_args_string(_gsc_funcid,param_count)+"\n"+_gsc_error_info
							gsc_error _gsc_error, "Function: "+gs_function_get_name(_gsc_funcid)+"\n"+_gsc_error_info
							break
						}
					}

					gs_log_Write gs_function_get_name(_gsc_funcid)+gs_function_get_combined_args_string(_gsc_funcid,param_count)
					
					gs_function_call _gsc_funcid	//	ߌĂяo
					if _gsc_break {
						break
					}
					continue
				}
				if code_type == 'v' {	//	ϐ
					_gsc_funcsize = wpeek(_gsc_code_bin,_gsc_addr) : _gsc_addr += 2
					gs_calculate_core _gsc_code_bin, _gsc_addr
					_gsc_addr += _gsc_funcsize
					if _gsc_error {
						gs_log_Write "ERROR: Variable operation\n"+_gsc_error_info
						gsc_error _gsc_error, "Function: Variable operation\n"+_gsc_error_info
						break
					}
					gs_log_Write "var: addr="+_gsc_op_head+"("+_gsc_funcsize+") "+gs_calculate_getstackvarinfo()
					continue
				}
				if code_type == 'e' {	//	I_
					gs_log_Write "EOF: addr="+_gsc_op_head
					gs_thread_delete _gsc_thread
					break
				}
				
				//	code_type  unknown Ȃ̂ŃG[
				gs_log_Write "Error: Unknown. addr="+_gsc_op_head
				_gsc_error = -1 : _gsc_error_info = "unknown error."
				break
			loop

			gs_log_Push
			gs_log_Write "Thread end: "+_gsc_thread

			return

#global

#endif