
#ifndef __Mod_GScript_Function__
#define __Mod_GScript_Function__

//---- ߊǗW[
#module	mod_gs_function \
	id, \
	name, \
	f_label, \
	rule, \
	type, \
	count

	#modinit
		mod_GetID id
		name		= ""
		f_label		= *TEMP@ModGS_Function
		rule		= 0
		dim type, 8
		count		= 0
		return id

	#modterm
		return

	#modfunc _gs_function_add str p_name, var p_vlabel, int p_prm1, int p_prm2, int p_prm3, int p_prm4, int p_prm5, int p_prm6, int p_prm7, int p_prm8
		if vartype(p_vlabel) ! 1 : return -1
		name		= p_name
		f_label		= p_vlabel
		type		= p_prm1, p_prm2, p_prm3, p_prm4, p_prm5, p_prm6, p_prm7, p_prm8
		count		= 0
		if p_prm1 > 0 : count++ : else : return 0
		if p_prm2 > 0 : count++ : else : return 0
		if p_prm3 > 0 : count++ : else : return 0
		if p_prm4 > 0 : count++ : else : return 0
		if p_prm5 > 0 : count++ : else : return 0
		if p_prm6 > 0 : count++ : else : return 0
		if p_prm7 > 0 : count++ : else : return 0
		if p_prm8 > 0 : count++ : else : return 0
		return 0

	#modfunc _gs_function_set_rule var p_var
		rule = p_var
		return

	#modcfunc _gs_function_get_rule_type
		return vartype(rule)

	#modfunc _gs_function_get_rule var p_var
		p_var = rule
		return

	#modcfunc _gs_function_get_p_count
		return count

	#modcfunc _gs_function_get_p_type int p_id
		return type(p_id)

	#modfunc _gs_function_get_label var p_var
		p_var = f_label
		return

	#modcfunc _gs_function_get_name
		return name

	#modfunc _gs_function_call
		gosub f_label
		return

#global

#module "ModGS_Function"
*TEMP@ModGS_Function:return

	#deffunc gs_function_create_container
		dimtype Gmd_Function_Container, 5, 1
		return

	#deffunc gs_function_clear
		foreach Gmd_Function_Container@ModGS_Function
			gs_define_delete _gs_function_get_name(Gmd_Function_Container@ModGS_Function(cnt))
			delmod Gmd_Function_Container@ModGS_Function(cnt)
		loop
		return

	#deffunc gs_function_init
		if vartype(Gmd_Function_Container@ModGS_Function) == 5 {
			gs_function_clear
		} else {
			gs_function_create_container
		}
		newmod Gmd_Function_Container@ModGS_Function, mod_gs_function
		return

	#defcfunc gs_function_search str p_string
		gs_define_searchf p_string
		id = abs(stat)
		if (id) {
			if (gs_define_get_type(id) == GSMD_DEFINE_TYPE_FUNC) || (gs_define_get_type(id) == GSMD_DEFINE_TYPE_CFUNC) {
				id = gs_define_get_value(id)
			} else {
				id = -1
			}
		} else {
			id = -1
		}
		return id

	#deffunc gs_function_add	int p_type, str p_name, var p_vlabel, int p_prm1, int p_prm2, int p_prm3, int p_prm4, int p_prm5, int p_prm6, int p_prm7, int p_prm8
		//	str p0, var p1, int p2, int p3, int p4, int p5, int p6, int p7, int p8, int p9
		;name = p_name
		if (gs_function_search(p_name) == -1) {	//	o^
			newmod Gmd_Function_Container@ModGS_Function, mod_gs_function
			id = stat
		} else {
			return -1
		}
		_gs_function_add Gmd_Function_Container@ModGS_Function(id), p_name, p_vlabel, p_prm1, p_prm2, p_prm3, p_prm4, p_prm5, p_prm6, p_prm7, p_prm8
		gs_define_add_func p_name, id, p_type
		return id

	#deffunc gs_function_delete str p0
		name = p0
		if (gs_function_search(name) == -1) {	//	o^
			return -1
		}
		gs_define_delete p0
		delmod Gmd_Function_Container@ModGS_Function(id)
		return id

	#deffunc gs_function_rule str p0, var p1
		name = p0
		if (gs_function_search(name) == -1) {	//	o^
			return -1
		}
		_gs_function_set_rule Gmd_Function_Container@ModGS_Function(id), p1
		return id

	#deffunc gs_function_return var p_var, int p_type
		_gsc_return = p_var
		if (_gsc_return_type == 0) {
			_gsc_return_type = vartype(_gsc_return)
		} else {
			_gsc_return_type = p_type
		}
		if (_gsc_return_type == 4) {	//	int
			_gsc_sv_stat = _gsc_return
			return
		}
		if (_gsc_return_type == 3) {	//	double
			_gsc_sv_refdval = _gsc_return
			return
		}
		if (_gsc_return_type == 2) {	//	str
			_gsc_sv_refstr = _gsc_return
			return
		}
		if (_gsc_return_type == 1) {	//	label
			return
		}
		return

#if GSMD_LOG = 1
	//	RÄĕԂ
	#defcfunc gs_function_get_combined_args_string int p_func, int p_args, local _ret
		_ret = ""
		if p_args > 0 : _ret += " "+ gs_function_get_args_string(p_func, 0, _gsc_p1) : else : return _ret
		if p_args > 1 : _ret += ","+ gs_function_get_args_string(p_func, 1, _gsc_p2)
		if p_args > 2 : _ret += ","+ gs_function_get_args_string(p_func, 2, _gsc_p3)
		if p_args > 3 : _ret += ","+ gs_function_get_args_string(p_func, 3, _gsc_p4)
		if p_args > 4 : _ret += ","+ gs_function_get_args_string(p_func, 4, _gsc_p5)
		if p_args > 5 : _ret += ","+ gs_function_get_args_string(p_func, 5, _gsc_p6)
		if p_args > 6 : _ret += ","+ gs_function_get_args_string(p_func, 6, _gsc_p7)
		if p_args > 7 : _ret += ","+ gs_function_get_args_string(p_func, 7, _gsc_p8)
		return _ret

	#defcfunc gs_function_get_args_string int p_func, int p_args, array p_var, local _temp
		_temp = _gs_function_get_p_type(Gmd_Function_Container@ModGS_Function(p_func),p_args)
		if _temp == GSMD_FUNC_PARAM_VARIABLE {
			if p_var(1) >= 1 {
				return gs_variable_get_name( p_var)+"("+p_var(2)+","+p_var(3)+","+p_var(4)+","+p_var(5)+")"
			}
			return gs_variable_get_name( p_var)
		}
		if _temp == GSMD_FUNC_PARAM_LABEL {
			return gs_label_get_name( p_var)
		}
		return p_var
#endif

	#define global ctype	gs_function_get_rule_type(%1)		_gs_function_get_rule_type(Gmd_Function_Container@ModGS_Function(%1))
	#define global			gs_function_get_rule(%1,%2)			_gs_function_get_rule Gmd_Function_Container@ModGS_Function(%1), %2
	#define global ctype	gs_function_get_p_count(%1)			_gs_function_get_p_count(Gmd_Function_Container@ModGS_Function(%1))
	#define global ctype	gs_function_get_p_type(%1,%2)		_gs_function_get_p_type(Gmd_Function_Container@ModGS_Function(%1),%2)
	#define global			gs_function_get_label(%1,%2)		_gs_function_get_label Gmd_Function_Container@ModGS_Function(%1), %2
	#define global ctype	gs_function_get_name(%1)			_gs_function_get_name(Gmd_Function_Container@ModGS_Function(%1))
	#define global			gs_function_call(%1)				_gs_function_call Gmd_Function_Container@ModGS_Function(%1)

#global

gs_function_init

#define global			gsc_Func(%1,%2,%3=0,%4=0,%5=0,%6=0,%7=0,%8=0,%9=0,%10=0)	_temp@ModGS_Temp=%2:gs_function_add GSMD_DEFINE_TYPE_FUNC,getpath(%1,16),_temp@ModGS_Temp,%3,%4,%5,%6,%7,%8,%9,%10
#define global			gsc_cFunc(%1,%2,%3=0,%4=0,%5=0,%6=0,%7=0,%8=0,%9=0,%10=0)	_temp@ModGS_Temp=%2:gs_function_add GSMD_DEFINE_TYPE_CFUNC,getpath(%1,16),_temp@ModGS_Temp,%3,%4,%5,%6,%7,%8,%9,%10
#define global			gsc_func_Delete(%1)		gs_function_delete getpath(%1,16)
#define global			gsc_func_Rule(%1,%2)	_temp@ModGS_Temp=%2:gs_function_rule getpath(%1,16),_temp@ModGS_Temp

#define global			gsc_Return(%1,%2=0)		_temp@ModGS_Temp=%1:gs_function_return _temp@ModGS_Temp,%2

;#define global ctype	gsc_function_GetArgsString(%1=0,%2=0)	gs_function_get_args_string(%1,%2)

#endif